#!/usr/bin/env python
# -*- coding=iso-8859-1 -*-
"""
Add/replace an image in the article DB. Use this when upcscan couldn't
find an image on Amazon.
"""

from __future__ import with_statement
import sqlite3
import urllib2
import sys

def download(url):
    data = None
    print 'Downloading %s' % url
    fh = urllib2.urlopen(url)
    data = fh.read()
    fh.close()
    #return buffer(data.decode(ISO_8859_1))
    return buffer(data)

def replaceImage(id, url):
    db = sqlite3.connect('articles.dat', isolation_level=None)
    
    c = db.cursor()
    c.execute('''select a.title, a.image from article a where a.id = ?''', (id,))
    row = c.fetchone()
    
    if row is None:
        raise Exception('No article with id %d found' % id)
    
    data = download(url)
    
    if row[1] is not None:
        print '"%s" already has an image. Replace it? [y/N]' % row[0]
        s = raw_input('> ')
        s = s.strip()
        if s[:1] not in ['y', 'Y']:
            return
        
        with open('backup.jpg', 'w') as fh:
            fh.write(row[1])
    
    print 'Saving new image in DB'
    c.execute('update article set image = ? where id = ?', (data, id))
    c.close()

if __name__ == '__main__':
    replaceImage(int(sys.argv[1]), sys.argv[2])
