#!/usr/bin/env python
# -*- coding=iso-8859-1 -*-
"""
Convert the articles in the DB to HTML.
"""

from __future__ import with_statement
import sqlite3
import codecs
from cStringIO import StringIO
from PIL import Image
import sys
import os

import locale
#print str(sys.stdout.encoding)
sys.stdout = codecs.getwriter(locale.getpreferredencoding())(sys.stdout)

db = sqlite3.connect('articles.dat')

c = db.cursor()
c.execute('''select a.id, a.asin, a.detailurl, a.title, a.creator, a.image, l.name, a.comment
from article a, location l
where a.location = l.id
order by a.title''')

def escape(s):
    return s.replace('&', '&amp;').replace('<', '&lt;').replace('>', '&gt;')

if not os.path.exists('images'):
    os.mkdir('images')

with codecs.open('index.html', 'w', 'iso-8859-1') as fh:
    fh.write(u'''<html>
<head>
<title>Articles</title>
<style>
td {
    vertical-align: top;
}
</style>
</head>
<body>
<table>
<tr>
        <th>Bild</th>
        <th>ASIN</th>
        <th>Title</th>
        <th>Autor/Knstler</th>
        <th>Standort</th>
        <th>Kommentar</th>
</tr>
''')
    
    tnSize = (128, 128)
    
    while True:
        row = c.fetchone()
        if row is None:
            break
        
        sys.stdout.write ('%s\r' % (row[3]+' '*79)[:79])
        sys.stdout.flush()
        if row[5]:
            img_data = StringIO(row[5])
            img = Image.open(img_data)
            img.thumbnail(tnSize, Image.ANTIALIAS)
            if img.mode == 'P':
                img = img.convert('RGB')
            
            with open('images/%d.jpg' % row[0], 'w') as img_fh:
                img_fh.write(row[5])

            #print row[0],img.mode
            img.save('images/_%d.jpg' % row[0], 'JPEG')
            size = img.size
        
        fh.write('<tr>\n')
        if row[5]:
            fh.write('<td><a href="image/%d.jpg"><img src="images/_%d.jpg" width="%d" height="%d" /></a></td>\n' % (
                row[0], row[0], size[0], size[1]
            ))
        else:
            print 'No image: %d %s' % (row[0], row[3])
            fh.write ('<td>No image %d</td>\n' % row[0])
        fh.write('<td>%s</td>\n' % row[1])
        fh.write('<td><a href="%s">%s</a></td>\n' % (row[2], escape(row[3])))

        s = escape(row[4]) if row[4] else '&nbsp;'
        fh.write ('<td>%s</td>\n' % s)
        
        s = escape(row[6]) if row[6] else '&nbsp;'
        fh.write ('<td>%s</td>\n' % s)
        
        s = escape(row[7]) if row[7] else '&nbsp;'
        fh.write ('<td>%s</td>\n' % s)
        
        fh.write('</tr>\n')
    
    fh.write('''</table>
</body>
</html>
''')

c.close()
db.close()
